package cn.hnthyy.thmz.service.thmz;

import cn.hnthyy.thmz.entity.thmz.Discount;

import java.util.List;

public interface DiscountService {
    /**
     * 新增折扣率功能
     * @param discount
     * @return
     */
    int save(Discount discount);

    /**
     * 修改折扣率
     * @param discount
     * @return
     */
    int modify(Discount discount);


    /**
     * 分页查询
     *
     *
     * @param discount
     * @return
     */
    List<Discount> queryDiscountWithPage(Discount discount);




    /**
     * 查询符合条件的总数
     *
     *
     * @param discount
     * @return
     */
    Integer queryDiscount(Discount discount);


    /**
     * 查询当天有效的折扣率
     * @return
     */
    List<Discount> queryDiscountForToday();

    /**
     * 按照主键查询营销计划
     * @param id
     * @return
     */
    Discount queryById(Long id);

    /**
     * 删除营销计划
     * @param id
     * @return
     */
    int removeById(Long id);

    /**
     * 获取当天的营销计划
     * @param deptType 科室类型 0-申请科室 1 -执行科室
     * @param deptNo 科室编码
     * @param chargeItemCode 收费项目编码
     * @return
     */
    Discount getDiscountRate(Integer deptType,String deptNo,String chargeItemCode);

    /**
     * 初始化缓存
     */
    void getCacheMap();
}
